Tag Parser: TagParser::Mp4Container Class Reference

Tag Parser 12.5.2 C++ library for reading and writing MP4 (iTunes), ID3, Vorbis, Opus, FLAC and Matroska tags

Loading...
Searching...
No Matches
Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
TagParser::Mp4Container Class Referencefinal

Implementation of GenericContainer<MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom>. More...

`#include <mp4container.h>`

Inheritance diagram for TagParser::Mp4Container:
[legend]
Collaboration diagram for TagParser::Mp4Container:
[legend]

## Public Member Functions
| Mp4Container (MediaFileInfo &fileInfo, std::uint64_t startOffset)
| Constructs a new container for the specified fileInfo at the specified startOffset.
| ~Mp4Container () override
bool | supportsTrackModifications () const override
| Returns whether the implementation supports adding or removing of tracks.
bool | isFragmented () const
| Returns whether the file is fragmented.
void | reset () override
| Discards all parsing results.
ElementPosition | determineTagPosition (Diagnostics &diag) const override
| Determines the position of the tags inside the file.
ElementPosition | determineIndexPosition (Diagnostics &diag) const override
| Determines the position of the index.
Public Member Functions inherited from TagParser::GenericContainer< MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom >
| GenericContainer (MediaFileInfo &fileInfo, std::uint64_t startOffset)
| Constructs a new container for the specified fileInfo at the specified startOffset.
| ~GenericContainer () override
| Destroys the container.
void | validateElementStructure (Diagnostics &diag, AbortableProgressFeedback &progress, std::uint64_t *paddingSize=nullptr)
| Parses all elements the file consists of.
MediaFileInfo & | fileInfo () const
| Returns the related file info.
Mp4Atom * | firstElement () const
| Returns the first element of the file if available; otherwiese returns nullptr.
const std::vector< std::unique_ptr< Mp4Atom > > & | additionalElements () const
| Returns all available additional elements.
Mp4Tag * | tag (std::size_t index) override
| Returns the tag with the specified index.
std::size_t | tagCount () const override
| Returns the number of tags attached to the container.
Mp4Track * | track (std::size_t index) override
| Returns the track with the specified index.
Mp4Track * | trackById (std::uint64_t id)
std::size_t | trackCount () const override
| Returns the number of tracks the container holds.
const std::vector< std::unique_ptr< Mp4Tag > > & | tags () const
| Returns the tags of the file.
const std::vector< std::unique_ptr< Mp4Track > > & | tracks () const
| Returns the tracks of the file.
Mp4Tag * | createTag (const TagTarget &target=TagTarget()) override
| Creates and returns a tag for the specified target.
bool | removeTag (Tag *tag) override
| Removes the specified tag from the container.
void | removeAllTags () override
| Removes all tags attached to the container.
bool | addTrack (Mp4Track *track)
| Adds the specified track to the container.
bool | removeTrack (AbstractTrack *track) override
| Removes the specified track to the container.
void | removeAllTracks () override
| Removes all tracks from the container.
Public Member Functions inherited from TagParser::AbstractContainer
virtual | ~AbstractContainer ()
| Destroys the container.
std::iostream & | stream ()
| Returns the related stream.
void | setStream (std::iostream &stream)
| Sets the related stream.
std::uint64_t | startOffset () const
| Returns the start offset in the related stream.
CppUtilities::BinaryReader & | reader ()
| Returns the related BinaryReader.
CppUtilities::BinaryWriter & | writer ()
| Returns the related BinaryWriter.
void | parseHeader (Diagnostics &diag, AbortableProgressFeedback &progress)
| Parses the header if not parsed yet.
void | parseTags (Diagnostics &diag, AbortableProgressFeedback &progress)
| Parses the tag information if not parsed yet.
void | parseTracks (Diagnostics &diag, AbortableProgressFeedback &progress)
| Parses the tracks of the file if not parsed yet.
void | parseChapters (Diagnostics &diag, AbortableProgressFeedback &progress)
| Parses the chapters of the file if not parsed yet.
void | parseAttachments (Diagnostics &diag, AbortableProgressFeedback &progress)
| Parses the attachments of the file if not parsed yet.
void | makeFile (Diagnostics &diag, AbortableProgressFeedback &progress)
| Rewrites the file to apply changed tag information.
bool | isHeaderParsed () const
| Returns an indication whether the header has been parsed yet.
bool | areTagsParsed () const
| Returns an indication whether the tags have been parsed yet.
bool | areTracksParsed () const
| Returns an indication whether the tracks have been parsed yet.
bool | areChaptersParsed () const
| Returns an indication whether the chapters have been parsed yet.
bool | areAttachmentsParsed () const
| Returns an indication whether the attachments have been parsed yet.
virtual AbstractChapter * | chapter (std::size_t index)
| Returns the chapter with the specified index.
virtual std::size_t | chapterCount () const
| Returns the number of chapters the container holds.
virtual AbstractAttachment * | createAttachment ()
| Creates and returns a new attachment.
virtual AbstractAttachment * | attachment (std::size_t index)
| Returns the attachment with the specified index.
virtual std::size_t | attachmentCount () const
| Returns the number of attachments the container holds.
std::uint64_t | version () const
| Returns the version if known; otherwise returns 0.
std::uint64_t | readVersion () const
| Returns the "read version" if known; otherwise returns 0.
const std::string & | documentType () const
| Returns a string that describes the document type if available; otherwise returns an empty string.
std::uint64_t | doctypeVersion () const
| Returns the document type version if known; otherwise returns 0.
std::uint64_t | doctypeReadVersion () const
| Returns the document type "read version" if known; otherwise returns 0.
const std::vector< std::string > & | titles () const
| Returns the title(s) of the file.
void | setTitle (std::string_view title, std::size_t segmentIndex=0)
| Sets the title for the specified segment.
virtual bool | supportsTitle () const
| Returns whether the title property is supported.
const std::vector< std::string > & | muxingApplications () const
| Returns the muxing applications specified as meta-data.
const std::vector< std::string > & | writingApplications () const
| Returns the writing applications specified as meta-data.
virtual std::size_t | segmentCount () const
| Returns the number of segments.
CppUtilities::TimeSpan | duration () const
| Returns the duration of the file if known; otherwise returns a time span of zero ticks.
CppUtilities::DateTime | creationTime () const
| Returns the creation time of the file if known; otherwise the returned date time is null.
CppUtilities::DateTime | modificationTime () const
| Returns the modification time of the file if known; otherwise the returned date time is null.
std::uint32_t | timeScale () const
| Returns the time scale of the file if known; otherwise returns 0.

## Static Public Attributes
static const CppUtilities::DateTime | epoch = DateTime::fromDate(1904, 1, 1)
| Dates within MP4 tracks are expressed as the number of seconds since this date.

## Protected Member Functions
void | internalParseHeader (Diagnostics &diag, AbortableProgressFeedback &progress) override
| Internally called to parse the header.
void | internalParseTags (Diagnostics &diag, AbortableProgressFeedback &progress) override
| Internally called to parse the tags.
void | internalParseTracks (Diagnostics &diag, AbortableProgressFeedback &progress) override
| Internally called to parse the tracks.
void | internalMakeFile (Diagnostics &diag, AbortableProgressFeedback &progress) override
| Internally called to make the file.
Protected Member Functions inherited from TagParser::AbstractContainer
| AbstractContainer (std::iostream &stream, std::uint64_t startOffset)
| Constructs a new container for the specified file stream at the specified startOffset.
virtual void | internalParseChapters (Diagnostics &diag, AbortableProgressFeedback &progress)
| Internally called to parse the chapters.
virtual void | internalParseAttachments (Diagnostics &diag, AbortableProgressFeedback &progress)
| Internally called to parse the attachments.
std::vector< std::string > & | muxingApplications ()
| Returns the muxing applications specified as meta-data.
std::vector< std::string > & | writingApplications ()
| Returns the writing applications specified as meta-data.

## Additional Inherited Members
Public Types inherited from TagParser::GenericContainer< MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom >
using | ContainerFileInfoType
using | ContainerTagType
using | ContainerTrackType
using | ContainerElementType
Protected Attributes inherited from TagParser::GenericContainer< MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom >
std::unique_ptr< Mp4Atom > | m_firstElement
std::vector< std::unique_ptr< Mp4Atom > > | m_additionalElements
std::vector< std::unique_ptr< Mp4Tag > > | m_tags
std::vector< std::unique_ptr< Mp4Track > > | m_tracks
Protected Attributes inherited from TagParser::AbstractContainer
std::uint64_t | m_version
std::uint64_t | m_readVersion
std::string | m_doctype
std::uint64_t | m_doctypeVersion
std::uint64_t | m_doctypeReadVersion
std::vector< std::string > | m_titles
CppUtilities::TimeSpan | m_duration
CppUtilities::DateTime | m_creationTime
CppUtilities::DateTime | m_modificationTime
std::uint32_t | m_timeScale
bool | m_headerParsed
bool | m_tagsParsed
bool | m_tracksParsed
bool | m_tracksAltered
bool | m_chaptersParsed
bool | m_attachmentsParsed

## Detailed Description

Implementation of GenericContainer<MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom>.

Definition at line 18 of file mp4container.h.

## Constructor & Destructor Documentation

## ◆ Mp4Container()

TagParser::Mp4Container::Mp4Container | ( | MediaFileInfo & | fileInfo,
|  | std::uint64_t | startOffset )

Constructs a new container for the specified fileInfo at the specified startOffset.

Definition at line 37 of file mp4container.cpp.

## ◆ ~Mp4Container()

TagParser::Mp4Container::~Mp4Container | ( |  | ) |
| override

Definition at line 43 of file mp4container.cpp.

## Member Function Documentation

## ◆ determineIndexPosition()

ElementPosition TagParser::Mp4Container::determineIndexPosition | ( | Diagnostics & | diag | ) | const
| overridevirtual

Determines the position of the index.

Returns
  Returns ElementPosition::BeforeData or ElementPosition::AfterData if the position could be determined; otherwise returns ElementPosition::Keep.

Remarks
  - It might be required to parse tracks before the index position can be determined.
  - Not be applicable for files composed of multiple segments.

See also
  MediaFileInfo::indexPosition()

Reimplemented from TagParser::AbstractContainer.

Definition at line 65 of file mp4container.cpp.

## ◆ determineTagPosition()

ElementPosition TagParser::Mp4Container::determineTagPosition | ( | Diagnostics & | diag | ) | const
| overridevirtual

Determines the position of the tags inside the file.

Returns
  Returns ElementPosition::BeforeData or ElementPosition::AfterData if the position could be determined; otherwise returns ElementPosition::Keep.

Remarks
  - It might be required to parse tags before the tag position can be determined.
  - Not be applicable for files composed of multiple segments.

See also
  MediaFileInfo::tagPosition()

Reimplemented from TagParser::AbstractContainer.

Definition at line 53 of file mp4container.cpp.

## ◆ internalMakeFile()

void TagParser::Mp4Container::internalMakeFile | ( | Diagnostics & | diag,
|  | AbortableProgressFeedback & | progress )
| overrideprotectedvirtual

Internally called to make the file.

Must be implemented when subclassing.

Exceptions

  Throws | Failure or a derived class when a parsing error occurs.
  Throws | std::ios_base::failure when an IO error occurs.

Reimplemented from TagParser::AbstractContainer.

Definition at line 223 of file mp4container.cpp.

## ◆ internalParseHeader()

void TagParser::Mp4Container::internalParseHeader | ( | Diagnostics & | diag,
|  | AbortableProgressFeedback & | progress )
| overrideprotectedvirtual

Internally called to parse the header.

Must be implemented when subclassing to provide this feature.

Exceptions

  Throws | Failure or a derived class when a parsing error occurs.
  Throws | std::ios_base::failure when an IO error occurs.

Reimplemented from TagParser::AbstractContainer.

Definition at line 77 of file mp4container.cpp.

## ◆ internalParseTags()

void TagParser::Mp4Container::internalParseTags | ( | Diagnostics & | diag,
|  | AbortableProgressFeedback & | progress )
| overrideprotectedvirtual

Internally called to parse the tags.

Must be implemented when subclassing to provide this feature.

Exceptions

  Throws | Failure or a derived class when a parsing error occurs.
  Throws | std::ios_base::failure when an IO error occurs.

Reimplemented from TagParser::AbstractContainer.

Definition at line 93 of file mp4container.cpp.

## ◆ internalParseTracks()

void TagParser::Mp4Container::internalParseTracks | ( | Diagnostics & | diag,
|  | AbortableProgressFeedback & | progress )
| overrideprotectedvirtual

Internally called to parse the tracks.

Must be implemented when subclassing to provide this feature.

Exceptions

  Throws | Failure or a derived class when a parsing error occurs.
  Throws | std::ios_base::failure when an IO error occurs.

Reimplemented from TagParser::AbstractContainer.

Definition at line 123 of file mp4container.cpp.

## ◆ isFragmented()

bool TagParser::Mp4Container::isFragmented | ( |  | ) | const
| inline

Returns whether the file is fragmented.

Track information needs to be parsed to detect fragmentation.

Definition at line 53 of file mp4container.h.

## ◆ reset()

void TagParser::Mp4Container::reset | ( |  | ) |
| overridevirtual

Discards all parsing results.

Reimplemented from TagParser::GenericContainer< MediaFileInfo, Mp4Tag, Mp4Track, Mp4Atom >.

Definition at line 47 of file mp4container.cpp.

## ◆ supportsTrackModifications()

bool TagParser::Mp4Container::supportsTrackModifications | ( |  | ) | const
| inlineoverridevirtual

Returns whether the implementation supports adding or removing of tracks.

Reimplemented from TagParser::AbstractContainer.

Definition at line 44 of file mp4container.h.

## Member Data Documentation

## ◆ epoch

const CppUtilities::DateTime TagParser::Mp4Container::epoch = DateTime::fromDate(1904, 1, 1)
| static

Dates within MP4 tracks are expressed as the number of seconds since this date.

Definition at line 29 of file mp4container.h.

The documentation for this class was generated from the following files:

- mp4/mp4container.h
- mp4/mp4container.cpp